-- Indicator profile initialization routine
-- Defines indicator profile properties and indicator parameters
-- TODO: Add minimal and maximal value of numeric parameters and default color of the streams
function Init()
    indicator:name("Trade Speedometer");
    indicator:description("Trade Speedometer");
    indicator:requiredSource(core.Bar);
    indicator:type(core.Oscillator);
    indicator.parameters:addString("Type", "Candle Type", "", "OC");
    indicator.parameters:addStringAlternative("Type", "Open / Close", "", "OC");
    indicator.parameters:addStringAlternative("Type", "High / Low", "", "HL");
    indicator.parameters:addColor("SOT_color", "Color of SOT", "Color of SOT", core.rgb(255, 0, 0));
end

-- Indicator instance initialization routine
-- Processes indicator parameters and creates output streams
-- TODO: Refine the first period calculation for each of the output streams.
-- TODO: Calculate all constants, create instances all subsequent indicators and load all required libraries
-- Parameters block
local Type;

local first;
local source = nil;

-- Streams block
local SOT = nil;

-- Routine
function Prepare(nameOnly)
    Type=instance.parameters.Type;
    source = instance.source;
    first = source:first();

    local name = profile:id() .. "(" .. source:name().. ", " .. Type  .. ")";
    instance:name(name);

    if (not (nameOnly)) then
        SOT = instance:addStream("SOT", core.Line, name, "SOT", instance.parameters.SOT_color, first);
		SOT:setPrecision(6) 
    end
end

-- Indicator calculation routine
-- TODO: Add your code for calculation output values
function Update(period)
    if period >= first and source:hasData(period) then
	
	
	    if Type == "OC" then
        SOT[period] = (source.open[period]-source.close[period]) /source.volume[period];
		else
		 SOT[period] = (source.high[period]-source.low[period]) /source.volume[period];
		end
    end
end

